/**
 * @license
 *-------------------------------------------------------------------------------------------
 * Copyright © 2025 Progress Software Corporation. All rights reserved.
 * Licensed under commercial license. See LICENSE.md in the package root for more information
 *-------------------------------------------------------------------------------------------
 */
"use client";
import * as i from "react";
import k from "prop-types";
import { validatePackage as Gt, useUnstyled as Yt, useId as $t, usePropsContext as jt, canUseDOM as rt, useAdaptiveModeContext as Jt, classNames as C, uDropDownList as b, getTabIndex as Qt, IconWrap as Xt, svgIconPropType as Zt, createPropsContext as Rt, Keys as w, uDropDownsActionSheet as Q } from "@progress/kendo-react-common";
import { FloatingLabel as en } from "@progress/kendo-react-labels";
import { caretAltDownIcon as tn, xIcon as nn } from "@progress/kendo-svg-icons";
import rn from "../common/ListContainer.mjs";
import on from "../common/ListFilter.mjs";
import ot from "../common/GroupStickyHeader.mjs";
import an from "../common/ListDefaultItem.mjs";
import ln from "../common/List.mjs";
import dt from "../common/DropDownBase.mjs";
import { getFilteredData as P, areSame as N, getItemValue as ve, isPresent as it, itemIndexStartsWith as sn, sameCharsOnly as dn, shuffleData as cn, matchText as at } from "../common/utils.mjs";
import { packageMetadata as un } from "../package-metadata.mjs";
import { Button as lt } from "@progress/kendo-react-buttons";
import { useLocalization as pn } from "@progress/kendo-react-intl";
import { dropDownListArrowBtnAriaLabel as st, messages as mn } from "../messages/index.mjs";
import { ActionSheet as fn, ActionSheetHeader as vn, ActionSheetContent as gn } from "@progress/kendo-react-layout";
const In = "Please select a value from the list!", Te = i.forwardRef((E, ct) => {
  Gt(un);
  const F = Yt(), ge = $t(E.id), r = jt(hn, E), {
    delay: ut = z.delay,
    tabIndex: pt = z.tabIndex,
    ignoreCase: Ie = z.ignoreCase,
    size: X = z.size,
    rounded: ze = z.rounded,
    fillMode: he = z.fillMode,
    groupMode: yn = z.groupMode
  } = r, ye = () => {
    if (rt)
      return U.current && U.current.ownerDocument || window.document;
  }, mt = () => {
    var e, n;
    (e = t == null ? void 0 : t.current) != null && e.wrapper && ((n = t == null ? void 0 : t.current) == null || n.wrapper.focus({ preventScroll: !0 }));
  }, L = () => {
    let e;
    return H.current !== void 0 && H.current !== null ? e = H.current : r.value !== void 0 ? e = r.value : p.value !== void 0 && p.value !== null ? e = p.value : r.defaultValue !== void 0 && r.defaultValue !== null && (e = r.defaultValue), !it(e) && r.defaultItem !== void 0 && r.defaultItem !== null && (e = r.defaultItem), e;
  }, ft = () => {
    const { dataItemKey: e } = r, n = P(E), a = L();
    return n.findIndex((c) => N(c, a, e));
  }, we = () => r.required !== void 0 ? r.required : z.required, xe = () => {
    const e = r.validationMessage !== void 0, n = L(), a = !we() || n !== null && n !== "" && n !== void 0, c = r.valid !== void 0 ? r.valid : a;
    return {
      customError: e,
      valid: c,
      valueMissing: n === null
    };
  }, vt = () => r.validityStyles !== void 0 ? r.validityStyles : z.validityStyles, oe = (e) => {
    ae.current = !0, e.focus(), window.setTimeout(() => ae.current = !1, 30);
  }, Se = () => {
    R.current && oe(R.current), r.adaptive && setTimeout(() => {
      R.current && oe(R.current);
    }, 300);
  }, gt = i.useCallback((e) => {
    for (const n of e)
      Tt(n.target.clientWidth);
  }, []), Oe = () => {
    ie.current && ie.current.setCustomValidity && ie.current.setCustomValidity(
      xe().valid ? "" : r.validationMessage || In
    );
  }, q = (e, n) => {
    const a = L();
    N(a, e, r.dataItemKey) || (r.value === void 0 && (n.data.value = e), t.current.updateComponentArgs({ value: e }), H.current = e, n.events.push({ type: "onChange" }));
  }, K = (e) => {
    var n;
    (n = t == null ? void 0 : t.current) == null || n.applyState(e), H.current = void 0;
  }, Z = (e, n) => {
    var s;
    const { virtual: a, dataItemKey: c, defaultItem: u } = r, m = P(E), v = a ? a.skip : 0, f = L(), o = e === -1 && u !== void 0 ? u : m[e - v], d = !N(o, f, c);
    q(o, n), d && ((s = t == null ? void 0 : t.current) == null || s.triggerPageChangeCornerItems(o, n));
  }, A = (e, n, a) => {
    var h, I;
    const { defaultItem: c, dataItemKey: u, virtual: m = { skip: 0, total: 0, pageSize: 0 } } = r, v = L(), f = P(E), o = (h = t == null ? void 0 : t.current) == null ? void 0 : h.vs, d = f.findIndex((y) => N(y, v, u)), s = (I = t == null ? void 0 : t.current) == null ? void 0 : I.navigation.navigate({
      current: m.skip + d,
      max: (o != null && o.enabled ? m.total : f.length) - 1,
      min: c !== void 0 ? -1 : 0,
      keyCode: n,
      skipItems: a || void 0
    });
    s !== void 0 && Z(s, e), K(e);
  }, It = (e) => {
    U.current = e, t.current.wrapper = e;
  }, ht = (e) => /* @__PURE__ */ i.createElement(
    "select",
    {
      name: r.name,
      ref: (n) => {
        ie.current = n;
      },
      tabIndex: -1,
      "aria-hidden": !0,
      title: r.label,
      style: { opacity: 0, width: 1, border: 0, zIndex: -1, position: "absolute", left: "50%" }
    },
    /* @__PURE__ */ i.createElement("option", { value: r.valueMap ? r.valueMap.call(void 0, e) : e })
  ), De = () => {
    const {
      textField: e,
      dataItemKey: n,
      virtual: a = { skip: 0 },
      focusedItemIndex: c = sn,
      filterable: u,
      skipDisabledItems: m = !0
    } = r, v = L(), f = P(E), o = r.filter ? r.filter : p.text;
    return m && e && !o && !v ? f.findIndex((d) => !d.disabled && d[e]) : it(v) && o === void 0 || u && o === "" ? f.findIndex((d) => N(d, v, n)) : o ? ke.current ? c(f, o, e) : f.findIndex((d) => N(d, v, n)) : a.skip === 0 ? 0 : -1;
  }, Ae = (e, n) => n !== void 0 && n !== -1 && e && e.length > 0 && e[n].disabled, Ce = () => {
    const e = P(E), n = t.current.initState(), a = De();
    Ae(e, a) && (q(null, n), K(n));
  }, Ee = (e) => {
    if (e.isPropagationStopped())
      return;
    const n = t.current.initState();
    n.syntheticEvent = e, p.focused || (n.data.focused = !0), Ce(), t.current.togglePopup(n), K(n);
  }, He = (e) => {
    var O, me, _, fe, J, tt, nt;
    e && e.target instanceof Element && e.target.nodeName === "INPUT" && e.stopPropagation && e.stopPropagation();
    const {
      filterable: n,
      disabled: a,
      defaultItem: c,
      leftRightKeysNavigation: u = !0,
      virtual: m = { skip: 0, total: 0, pageSize: 0 },
      dataItemKey: v,
      groupField: f = "",
      textField: o,
      skipDisabledItems: d = !0
    } = r, s = P(E), h = L(), I = s.findIndex((D) => N(D, h, v)), y = r.opened !== void 0 ? r.opened : p.opened, l = e.keyCode, T = l === w.home || l === w.end, M = l === w.up || l === w.down, j = !y && (e.altKey && l === w.down || l === w.enter || l === w.space), re = y && (e.altKey && l === w.up || l === w.esc), ue = u && (l === w.left || l === w.right), pe = M || ue && !n || T, S = t.current.initState();
    if (S.syntheticEvent = e, !a) {
      if (T && ((O = t == null ? void 0 : t.current) != null && O.vs.enabled))
        l === w.home ? m.skip !== 0 ? ((me = t == null ? void 0 : t.current) == null || me.triggerOnPageChange(S, 0, m.pageSize), V.current = !0) : q(s[0], S) : m.skip < m.total - m.pageSize ? ((_ = t == null ? void 0 : t.current) == null || _.triggerOnPageChange(
          S,
          m.total - m.pageSize,
          m.pageSize
        ), V.current = !0) : q(s[s.length - 1], S);
      else if (y && l === w.pageUp)
        e.preventDefault(), (fe = t == null ? void 0 : t.current) == null || fe.scrollPopupByPageSize(-1);
      else if (y && l === w.pageDown)
        e.preventDefault(), (J = t == null ? void 0 : t.current) == null || J.scrollPopupByPageSize(1);
      else if (y && l === w.enter) {
        const D = De();
        Ae(s, D) ? (q(null, S), K(S)) : Z(D, S), (tt = t == null ? void 0 : t.current) == null || tt.togglePopup(S), e.preventDefault();
      } else if (j || re)
        re && Ce(), (nt = t == null ? void 0 : t.current) == null || nt.togglePopup(S), e.preventDefault();
      else if (pe) {
        if (ke.current = !1, f !== "" && o)
          if (!d && y)
            A(S, l);
          else {
            let D;
            if (l === w.down || l === w.right) {
              const x = s.slice(I + 1).find((g) => !g.disabled && g[o]);
              D = x && s.findIndex((g) => g[o] === x[o]);
            } else if (l === w.up || l === w.left) {
              let x;
              if (I === 0 && c)
                D = -1;
              else if (I === -1)
                x = s, D = s.findIndex((g) => !g.disabled && g[o]);
              else {
                x = s.slice(0, I);
                let g = x.pop();
                for (; g && g.disabled; )
                  g = x.pop();
                D = g && s.findIndex((Ke) => Ke[o] === g[o]);
              }
            }
            if (D !== void 0) {
              const x = D - I;
              A(S, l, x);
            } else
              D === void 0 && s.findIndex((x) => x[o] === h[o]) === s.length - 1 && A(S, l);
          }
        else if (!d && y || T)
          A(S, l);
        else if (o) {
          let D;
          if (l === w.down || l === w.right) {
            const x = s.slice(I + 1).find((g) => !g.disabled && g[o]);
            D = x && s.findIndex((g) => g[o] === x[o]);
          } else if (l === w.up || l === w.left) {
            let x;
            if (I === 0 && c)
              D = -1;
            else if (I === -1)
              x = s, D = s.find((g) => !g.disabled && g[o]);
            else {
              x = s.slice(0, I);
              let g = x.pop();
              for (; g && g.disabled; )
                g = x.pop();
              D = g && s.findIndex((Ke) => Ke[o] === g[o]);
            }
          }
          if (D !== void 0) {
            const x = D - I;
            A(S, l, x);
          } else
            D === void 0 && s.findIndex((x) => x[o] === h[o]) === s.length - 1 && A(S, l);
        } else
          A(S, l);
        e.preventDefault();
      }
      K(S);
    }
  }, yt = (e) => {
    const n = t.current.initState();
    n.syntheticEvent = e.syntheticEvent, r.filter === void 0 && (n.data.text = e.target.value), t.current.filterChanged(e.target.value, n), ke.current = !0, K(n), te({ group: void 0, text: String(e.target.value) });
  }, Ve = () => {
    const e = r.filter !== void 0 ? r.filter : p.text;
    return r.filterable && /* @__PURE__ */ i.createElement(
      on,
      {
        value: e,
        ref: (n) => R.current = n && n.element,
        onChange: yt,
        onKeyDown: He,
        size: X,
        rounded: ze,
        fillMode: he,
        renderListFilterWrapper: !0
      }
    );
  }, wt = (e) => {
    var a;
    const n = t.current.initState();
    n.syntheticEvent = e, (a = t == null ? void 0 : t.current) == null || a.togglePopup(n), q(r.defaultItem, n), K(n);
  }, Be = () => {
    const { textField: e, defaultItem: n, dataItemKey: a } = r, c = L();
    return n !== void 0 && /* @__PURE__ */ i.createElement(
      an,
      {
        defaultItem: n,
        textField: e,
        selected: N(c, n, a),
        key: "defaultitemkey",
        onClick: wt
      }
    );
  }, xt = (e, n) => {
    var a;
    (a = t == null ? void 0 : t.current) == null || a.handleItemClick(e, n), H.current = void 0;
  }, St = (e) => {
    const { vs: n, list: a } = t.current;
    n.scrollHandler(e);
    const { groupField: c } = r;
    let u = P(E);
    if (!(!c || !u.length) && c) {
      const m = Ue.current = Ue.current || (n.enabled ? n.itemHeight : a ? a.children[0].offsetHeight : 0), f = e.target.scrollTop - n.skip * m;
      u = t.current.getGroupedDataModernMode(u, c);
      let o = u[0][c];
      for (let d = 1; d < u.length && !(m * d > f); d++)
        u[d] && u[d][c] && (o = u[d][c]);
      o !== p.group && te({ group: o });
    }
  }, We = () => {
    var l;
    const {
      textField: e,
      dataItemKey: n,
      virtual: a = { skip: 0, total: void 0 },
      groupHeaderItemRender: c,
      listNoDataRender: u,
      itemRender: m
    } = r, v = P(E), f = F && F.uDropDownList, o = t.current.vs, d = a.skip, s = r.opened !== void 0 ? r.opened : p.opened, h = t.current.getPopupSettings(), I = `translateY(${o.translate}px)`, y = L();
    return /* @__PURE__ */ i.createElement(
      ln,
      {
        id: be,
        show: s,
        data: v.slice(),
        focusedIndex: De(),
        value: y,
        textField: e,
        valueField: n,
        optionsGuid: $e,
        groupField: r.groupField,
        groupMode: "modern",
        listRef: (T) => o.list = t.current.list = T,
        wrapperStyle: { maxHeight: h.height },
        wrapperCssClass: C(b.listContent({ c: f })),
        listStyle: o.enabled ? { transform: I } : void 0,
        key: "listkey",
        skip: d,
        onClick: xt,
        itemRender: m,
        groupHeaderItemRender: c,
        noDataRender: u,
        onScroll: St,
        wrapperRef: o.scrollerRef,
        scroller: (l = t == null ? void 0 : t.current) == null ? void 0 : l.renderScrollElement(),
        ariaSetSize: a.total
      }
    );
  }, Dt = () => {
    var I;
    const { header: e, footer: n, adaptiveTitle: a, groupField: c, groupStickyHeaderItemRender: u, list: m } = r, v = P(E), f = r.opened !== void 0 ? r.opened : p.opened, o = F && F.uDropDownList, d = F && F.uDropDownsActionSheet, s = {
      navigatable: !1,
      navigatableElements: [],
      expand: f,
      animation: !0,
      onClose: (y) => Ee(y),
      className: C(
        Q.wrapper({
          c: d
        }),
        "k-adaptive-actionsheet"
      ),
      animationStyles: Y && $ && Y <= $.small ? { top: 0, width: "100%", height: "100%" } : void 0,
      position: Y && $ && Y <= $.small ? "fullscreen" : void 0
    };
    let { group: h } = p;
    return h === void 0 && c !== void 0 && (h = ve(v[0], c)), /* @__PURE__ */ i.createElement(fn, { ...s }, /* @__PURE__ */ i.createElement(vn, { className: C(Q.header({ c: d })) }, /* @__PURE__ */ i.createElement("div", { className: C(Q.titleBar({ c: d })) }, /* @__PURE__ */ i.createElement("div", { className: C(Q.title({ c: d })) }, /* @__PURE__ */ i.createElement("div", null, a)), /* @__PURE__ */ i.createElement("div", { className: C(Q.actions({ c: d })) }, /* @__PURE__ */ i.createElement(
      lt,
      {
        tabIndex: 0,
        "aria-label": "Cancel",
        "aria-disabled": "false",
        type: "button",
        fillMode: "flat",
        onClick: Ee,
        icon: "x",
        svgIcon: nn
      }
    ))), /* @__PURE__ */ i.createElement("div", { className: C(Q.titleBarGroup({ c: d })) }, Ve())), /* @__PURE__ */ i.createElement(gn, { overflowHidden: !0 }, e && /* @__PURE__ */ i.createElement("div", { className: C(b.listHeader({ c: o })) }, e), /* @__PURE__ */ i.createElement(
      "div",
      {
        className: C(
          b.list({
            c: o,
            size: X,
            virtual: (I = t == null ? void 0 : t.current) == null ? void 0 : I.vs.enabled
          })
        )
      },
      Be(),
      !m && h && v.length !== 0 && /* @__PURE__ */ i.createElement(
        ot,
        {
          group: h,
          groupMode: "modern",
          render: u
        }
      ),
      We()
    ), n && /* @__PURE__ */ i.createElement("div", { className: C(b.listFooter({ c: o })) }, n)));
  }, Ct = () => {
    p.focused && window.setTimeout(() => {
      p.focused && t.current.wrapper && oe(t.current.wrapper);
    });
  }, Et = (e) => {
    var n;
    (n = r.popupSettings) != null && n.onMouseDownOutside && r.popupSettings.onMouseDownOutside.call(void 0, e);
  }, kt = () => {
    const { header: e, footer: n, dir: a, groupField: c, groupStickyHeaderItemRender: u, list: m } = r, v = P(E), f = t.current, o = f.getPopupSettings(), d = r.opened !== void 0 ? r.opened : p.opened, s = o.width !== void 0 ? o.width : f.popupWidth, h = F && F.uDropDownList, I = {
      dir: a !== void 0 ? a : f.dirCalculated,
      width: s,
      popupSettings: {
        ...o,
        popupClass: C(
          o.popupClass,
          b.listContainer({
            c: h
          })
        ),
        anchor: o.anchor || U.current,
        show: d,
        onOpen: Se,
        onClose: Ct,
        onMouseDownOutside: Et
      },
      itemsCount: [v.length]
    };
    let { group: y } = p;
    return y === void 0 && c !== void 0 && (y = ve(v[0], c)), /* @__PURE__ */ i.createElement(rn, { ...I }, Ve(), e && /* @__PURE__ */ i.createElement("div", { className: C(b.listHeader({ c: h })) }, e), /* @__PURE__ */ i.createElement(
      "div",
      {
        className: C(
          b.list({
            c: h,
            size: X,
            virtual: t.current.vs.enabled
          })
        )
      },
      Be(),
      !m && y && v.length !== 0 && /* @__PURE__ */ i.createElement(ot, { group: y, groupMode: "modern", render: u }),
      We()
    ), n && /* @__PURE__ */ i.createElement("div", { className: C(b.listFooter({ c: h })) }, n));
  }, Lt = (e) => {
    const { dataItemKey: n } = r, a = P(E), c = L();
    let u = a.map((M, j) => ({ item: M, itemIndex: j }));
    const m = G.current.word, v = G.current.last, f = dn(m, v);
    let o = u.length, d = Math.max(
      0,
      a.findIndex((M) => N(M, c, n))
    ), s;
    r.defaultItem && (s = { item: r.defaultItem, itemIndex: -1 }, o += 1, d += 1), d += f ? 1 : 0, u = cn(u, d, s);
    let h, I, y, l = 0;
    const { textField: T } = r;
    for (; l < o; l++)
      if (h = ve(u[l].item, T), I = f && at(h, v, Ie), y = at(h, m, Ie), I || y) {
        l = u[l].itemIndex;
        break;
      }
    if (l !== o) {
      const M = t.current.initState();
      M.syntheticEvent = e, Z(l, M), K(M), H.current = void 0;
    }
  }, bt = (e) => {
    clearTimeout(qe.current), r.filterable || (qe.current = window.setTimeout(() => G.current.word = "", ut), Lt(e));
  }, Pt = (e) => {
    ae.current || t.current.handleFocus(e);
  }, Mt = (e) => {
    if (ae.current || !p.focused)
      return;
    const n = r.opened !== void 0 ? r.opened : p.opened, a = t.current.initState();
    a.syntheticEvent = e, a.data.focused = !1, a.events.push({ type: "onBlur" }), n && Ce(), n && !Fe && t.current.togglePopup(a), K(a);
  }, Nt = (e) => {
    if (r.filterable || e.which === 0 || e.keyCode === w.enter)
      return;
    let n = String.fromCharCode(e.charCode || e.keyCode);
    Ie && (n = n.toLowerCase()), n === " " && e.preventDefault(), G.current = {
      word: G.current.word + n,
      last: G.current.last + n
    }, bt(e);
  }, Ft = () => {
    const e = t.current.initState();
    e.data.opened = p.opened, t.current.togglePopup(e), K(e);
  }, _e = i.useRef(null), U = i.useRef(null), ie = i.useRef(), R = i.useRef(null);
  i.useImperativeHandle(
    _e,
    () => ({
      get element() {
        return U.current;
      },
      get index() {
        return ft();
      },
      get name() {
        return r.name;
      },
      get validity() {
        return xe();
      },
      get value() {
        return L();
      },
      get focused() {
        return p.focused;
      },
      get opened() {
        return p.opened;
      },
      focus: mt,
      props: r,
      togglePopup: Ft
    })
  ), i.useImperativeHandle(
    ct,
    () => _e.current
  );
  const qe = i.useRef(null), G = i.useRef({ word: "", last: "" }), ae = i.useRef(!1), H = i.useRef(null), V = i.useRef(!1), ke = i.useRef(!1), B = i.useRef({}), Le = i.useRef({}), t = i.useRef(
    new dt({
      props: E,
      setState: () => {
      },
      state: {},
      forceUpdate: () => {
      },
      element: null,
      value: null,
      handleItemSelect: () => {
      }
    })
  ), Ue = i.useRef(0), ee = i.useRef(null), [p, Kt] = i.useState({}), [Y, Tt] = i.useState(), [, Ge] = i.useReducer((e) => e, !0), zt = pn(), te = (e) => {
    Kt({ ...p, ...e });
  };
  i.useEffect(() => {
    t.current.updateComponentArgs({
      props: E,
      setState: te,
      state: p,
      forceUpdate: Ge,
      element: U.current,
      handleItemSelect: Z,
      value: L()
    });
  }, [te, p, Ge, Z, L]), i.useEffect(() => {
    var d, s, h, I, y, l, T, M, j, re, ue, pe, S;
    const { dataItemKey: e, virtual: n, groupField: a = "", textField: c } = r, u = P(E), m = B.current.virtual ? B.current.virtual.total : 0, v = r.opened !== void 0 ? r.opened : p.opened, f = B.current.opened !== void 0 ? B.current.opened : Le.current.opened, o = !f && v;
    if ((d = t == null ? void 0 : t.current) == null || d.didUpdate(), (s = t == null ? void 0 : t.current) != null && s.getPopupSettings().animate || o && Se(), n && n.total !== m)
      (h = t == null ? void 0 : t.current) == null || h.vs.calcScrollElementHeight(), (I = t == null ? void 0 : t.current) == null || I.vs.reset();
    else {
      const O = L(), me = B.current.value !== void 0 ? B.current.value : Le.current.value;
      let _ = u.findIndex((J) => N(J, O, e));
      a !== "" && O && c && (_ = (l = (y = t == null ? void 0 : t.current) == null ? void 0 : y.getGroupedDataModernMode(u, a)) == null ? void 0 : l.map((J) => J[c]).indexOf(O[c]));
      const fe = !N(me, O, e);
      o && n ? (T = t == null ? void 0 : t.current) == null || T.scrollToVirtualItem(n, _) : o && !n ? (Se(), u && u.length !== 0 && ((M = t == null ? void 0 : t.current) == null || M.resetGroupStickyHeader(u[0][a], {
        setState: te,
        group: p.group,
        state: p
      })), (j = t == null ? void 0 : t.current) == null || j.scrollToItem(_)) : v && f && O && fe && !V.current ? (ue = t == null ? void 0 : t.current) == null || ue.scrollToItem(_, (re = t == null ? void 0 : t.current) == null ? void 0 : re.vs.enabled) : v && f && V.current && (V.current && n && n.skip === 0 ? (pe = t == null ? void 0 : t.current) == null || pe.vs.reset() : V.current && n && n.skip === n.total - n.pageSize && ((S = t == null ? void 0 : t.current) == null || S.vs.scrollToEnd()));
    }
    V.current = !1, Le.current = p, B.current = r, Oe();
  }), i.useEffect(() => {
    var e, n;
    return ee.current = rt && window.ResizeObserver && new window.ResizeObserver(gt.bind(void 0)), (e = t == null ? void 0 : t.current) == null || e.didMount(), Oe(), (n = ye()) != null && n.body && ee.current && ee.current.observe(ye().body), () => {
      var a;
      (a = ye()) != null && a.body && ee.current && ee.current.disconnect();
    };
  }, []);
  const Ye = ge + "-accessibility-id", be = ge + "-listbox-id", $e = ge + "-guid", Ot = zt.toLanguageString(
    st,
    mn[st]
  ), {
    style: le,
    className: At,
    label: Pe,
    dir: Ht,
    virtual: W,
    adaptive: wn,
    dataItemKey: Vt,
    disabled: se,
    loading: je,
    iconClassName: Je,
    svgIcon: Qe,
    valueRender: Xe
  } = r, Me = r.opened !== void 0 ? r.opened : p.opened, de = L(), Ne = ve(de, r.textField), Ze = !vt() || xe().valid, ce = t.current, Bt = ce.vs, ne = F && F.uDropDownList;
  Bt.enabled = W !== void 0;
  const $ = Jt(), Fe = !!(Y && $ && Y <= $.medium && E.adaptive);
  W !== void 0 && (ce.vs.skip = W.skip, ce.vs.total = W.total, ce.vs.pageSize = W.pageSize);
  const Wt = P(E), { focused: _t } = p, qt = Wt.findIndex((e) => N(e, de, Vt)), Re = /* @__PURE__ */ i.createElement("span", { id: Ye, className: C(b.inputInner({ c: ne })) }, Ne && /* @__PURE__ */ i.createElement("span", { className: C(b.inputText({ c: ne })) }, Ne)), Ut = Xe !== void 0 ? Xe.call(void 0, Re, de) : Re, et = /* @__PURE__ */ i.createElement(i.Fragment, null, /* @__PURE__ */ i.createElement(
    "span",
    {
      ref: It,
      className: C(
        b.wrapper({
          c: ne,
          size: X,
          rounded: ze,
          fillMode: he,
          focused: _t,
          disabled: se,
          invalid: !Ze,
          loading: je,
          required: we()
        }),
        At
      ),
      style: Pe ? { ...le, width: void 0 } : le,
      dir: Ht,
      onMouseDown: Me ? (e) => {
        e.target.nodeName !== "INPUT" && (oe(t.current.wrapper), e.preventDefault());
      } : void 0,
      onFocus: Pt,
      onBlur: Mt,
      tabIndex: Qt(pt, se),
      accessKey: r.accessKey,
      onKeyDown: He,
      onKeyPress: Nt,
      onClick: se ? void 0 : Ee,
      role: "combobox",
      "aria-required": we(),
      "aria-disabled": se || void 0,
      "aria-haspopup": "listbox",
      "aria-expanded": Me || !1,
      "aria-owns": be,
      "aria-activedescendant": Me ? "option-" + $e + "-" + (qt + (W ? W.skip : 0)) : void 0,
      "aria-label": r.ariaLabel || r.label,
      "aria-labelledby": r.ariaLabelledBy,
      "aria-describedby": r.ariaDescribedBy || Ye,
      "aria-controls": be,
      id: r.id,
      title: r.title
    },
    Ut,
    je && /* @__PURE__ */ i.createElement(Xt, { className: C(b.loadingIcon({ c: ne })), name: "loading" }),
    /* @__PURE__ */ i.createElement(
      lt,
      {
        tabIndex: -1,
        type: "button",
        "aria-label": Ot,
        size: X,
        fillMode: he,
        iconClass: Je,
        className: C(b.inputButton({ c: ne })),
        rounded: null,
        themeColor: "base",
        icon: Je ? void 0 : "caret-alt-down",
        svgIcon: Qe || tn,
        onMouseDown: (e) => p.focused && e.preventDefault()
      }
    ),
    ht(de),
    !Fe && kt()
  ), Fe && Dt());
  return Pe ? /* @__PURE__ */ i.createElement(
    en,
    {
      label: Pe,
      editorValue: Ne,
      editorValid: Ze,
      editorDisabled: r.disabled,
      style: { width: le ? le.width : void 0 },
      children: et
    }
  ) : et;
});
Te.propTypes = {
  delay: k.number,
  ignoreCase: k.bool,
  iconClassName: k.string,
  svgIcon: Zt,
  defaultItem: k.any,
  valueRender: k.func,
  valueMap: k.func,
  validationMessage: k.string,
  required: k.bool,
  id: k.string,
  ariaLabelledBy: k.string,
  ariaDescribedBy: k.string,
  ariaLabel: k.string,
  leftRightKeysNavigation: k.bool,
  title: k.string,
  groupField: k.string,
  list: k.any,
  skipDisabledItems: k.bool
};
const z = {
  delay: 500,
  tabIndex: 0,
  ignoreCase: !0,
  ...dt.defaultProps,
  required: !1,
  size: "medium",
  rounded: "medium",
  fillMode: "solid",
  groupMode: "modern"
};
Te.displayName = "KendoReactDropDownList";
const hn = Rt();
Te.displayName = "KendoReactDropDownList";
export {
  Te as DropDownList,
  hn as DropDownListPropsContext,
  z as dropDownListDefaultProps
};
